import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { FormRecord, FormRecordParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询表单设计
 */
export async function pageFormRecord(params: FormRecordParam) {
  const res = await request.get<ApiResult<PageResult<FormRecord>>>(
    MODULES_API_URL + '/cms/form-record/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询表单设计列表
 */
export async function listFormRecord(params?: FormRecordParam) {
  const res = await request.get<ApiResult<FormRecord[]>>(
    MODULES_API_URL + '/cms/form-record',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加表单设计
 */
export async function addFormRecord(data: FormRecord) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form-record',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改表单设计
 */
export async function updateFormRecord(data: FormRecord) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form-record',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除表单设计
 */
export async function removeFormRecord(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form-record/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除表单设计
 */
export async function removeBatchFormRecord(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form-record/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询表单设计
 */
export async function getFormRecord(id: number) {
  const res = await request.get<ApiResult<FormRecord>>(
    MODULES_API_URL + '/cms/form-record/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/form-record/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
